<?php
register_nav_menus (
	array (
		'main-nav' => 'Main'
	)
);

if(!function_exists('output_nc_sitemap')) {
	function output_nc_sitemap($content) {
		$thankYouPage = get_page_by_path('thank-you', OBJECT, 'page');
		$thankYouPageID = $thankYouPage->ID;
		if($thankYouPageID) {$args = "echo=0&exclude={$thankYouPageID}&title_li=";}
		else {$args = "echo=0&title_li=";}
		if(is_page(array('sitemap','site-map'))) $content .= "<h1>Site Map</h1><ul>" . wp_list_pages($args) . "</ul>";
		return $content;
	}
}
add_filter( 'the_content', 'output_nc_sitemap' );

if(!function_exists('child_pages_shortcode')) {
	function child_pages_shortcode($atts) {
		global $post;
		extract( shortcode_atts( array('id' => $post->ID), $atts ) );
	  	$children = wp_list_pages('title_li=&child_of='.$id.'&echo=0');
	  	if ($children) {
	  		$children = "<ul>" . $children . "</ul>";
	  		return $children;
	  	}
	}
}
add_shortcode('child_pages', 'child_pages_shortcode');

if(!function_exists('new_excerpt_more')) {
	function new_excerpt_more($more) {
		global $post;
		return '...  <a href="'. get_permalink($post->ID) . '">Read More &raquo;</a>';
	}
}
add_filter('excerpt_more', 'new_excerpt_more');

if(!function_exists('my_excerpt_length')) {
	function my_excerpt_length($length) {
		return 54;
	}
}
add_filter('excerpt_length', 'my_excerpt_length');

if(!function_exists('nextclient_pagination')) {
	function nextclient_pagination() {
		global $wp_query;
		if ( $wp_query->max_num_pages > 1 ) : ?>
			<div id="nav-below" class="navigation">
				<div class="nav-previous"><?php next_posts_link( __( '<span class="meta-nav">&larr;</span> Older posts') ); ?></div>
				<div class="nav-next"><?php previous_posts_link( __( 'Newer posts <span class="meta-nav">&rarr;</span>') ); ?></div>
			</div><!-- #nav-above -->
		<?php endif;
	}
}

if(!function_exists('allow_editor_to_mod_menus')) {
	function allow_editor_to_mod_menus() {
		$role_object = get_role( 'editor' );
		$role_object->add_cap( 'edit_theme_options' );
	}
}
allow_editor_to_mod_menus();

if ( function_exists( 'add_theme_support' ) ) {
	add_theme_support( 'post-thumbnails' );
        set_post_thumbnail_size( 150, 150, true );
}

if ( function_exists( 'add_image_size' ) ) {
	add_image_size( 'postThumbMult', 150, 150, true );
	add_image_size( 'postThumbSingle', 200, 200, true );
}


if(!function_exists('add_sharing_capabilities_nc')) {
	function add_sharing_capabilities_nc() {
		global $nc_sharethis_publisherID;
		if(isset($nc_sharethis_publisherID)) : ?>
			<script type="text/javascript">var switchTo5x=true;</script>
			<script type="text/javascript" src="http://w.sharethis.com/button/buttons.js"></script>
			<?php
			global $disable_browserlock_share;
			if(is_page() && $disable_browserlock_share != 1) : ?>
				<script type="text/javascript" src="http://s.sharethis.com/loader.js"></script>
			<?php else : ?>
				<script type="text/javascript">stLight.options({publisher: "<?php echo $nc_sharethis_publisherID; ?>", shorten:false, onhover: false}); </script>
			<?php endif; ?>
		<?php endif;
	}
}
// add_action('wp_head', 'add_sharing_capabilities_nc');

if(!function_exists('add_sharing_capabilities_nc_footer')) {
	function add_sharing_capabilities_nc_footer() {
		global $nc_sharethis_publisherID;
		if(isset($nc_sharethis_publisherID)) : ?>
			<?php
			global $disable_browserlock_share;
			if( is_page() && $disable_browserlock_share != 1 ) : ?>
			<script>
			var options={ "publisher": "<?php echo $nc_sharethis_publisherID; ?>", "position": "left", "ad": { "visible": false, "openDelay": 5, "closeDelay": 0}, "chicklets": { "items": ["facebook", "twitter", "linkedin", "googleplus", "sharethis"]}, 'shorten': false};
			var st_hover_widget = new sharethis.widgets.hoverbuttons(options);
			</script>
			<?php endif; ?>
		<?php endif;
	}
}
// add_action('wp_footer', 'add_sharing_capabilities_nc_footer');

if(!function_exists('add_sharing_capabilities_nc_content')) {
	function add_sharing_capabilities_nc_content($content) {
		if(is_page()) return $content;
		if(is_single() && has_post_thumbnail() ) $content = the_post_thumbnail('postThumbSingle', array('class' => 'postThumbSingle')) . $content;
		$content .= shareThisWrapper();
		return $content;
	}
}
// add_filter('the_content', 'add_sharing_capabilities_nc_content');

if(!function_exists('copyrightYears')) {
	function copyrightYears($startYear) {
		$curYear = date("Y");
		if( $curYear > $startYear ) {
			echo $startYear . ' - ' . $curYear;
		} else {
			echo $curYear;
		}
	}
}
if(!function_exists('shareThisWrapper')) {
	function shareThisWrapper($suffix = "") {

		if( has_post_thumbnail() ) {
			$id = get_the_ID();
			$pIMG = get_the_post_thumbnail($id, 'postThumbMult');
			$start = stripos($pIMG, 'src=') + 5;
			$pIMG = substr($pIMG, $start);
			$end = stripos($pIMG, '"');
			$pIMG = substr($pIMG, 0, $end);
			$custom_IMG = "st_image='{$pIMG}'";
		} else {
			$custom_IMG = '';
		}
		$pTITLE = get_the_title();
		$pLINK = get_permalink();

		$tempo = <<<EOT
			<div id="stw{$suffix}" class="shareThisWrapper">
				<span class='st_facebook{$suffix}' displayText='' st_url="$pLINK" st_title="$pTITLE" $custom_IMG></span>
				<span class='st_twitter{$suffix}' displayText='' st_url="$pLINK" st_title="$pTITLE" $custom_IMG></span>
				<span class='st_linkedin{$suffix}' displayText='' st_url="$pLINK" st_title="$pTITLE" $custom_IMG></span>
				<span class='st_googleplus{$suffix}' displayText='' st_url="$pLINK" st_title="$pTITLE" $custom_IMG></span>				
				<span class='st_sharethis{$suffix}' displayText='' st_url="$pLINK" st_title="$pTITLE" $custom_IMG></span>
			</div>
EOT;
		return $tempo;
	}
}
if(!function_exists('nc_generate_more_posts_by_author_link')){
	function nc_generate_more_posts_by_author_link() {
		global $nc_author_name, $nc_author_url;

		if(isset($nc_author_name)) {$nc_this_is_the_author_name = $nc_author_name;}
		else {$nc_this_is_the_author_name	= get_the_author();}

		if(isset($nc_author_url)) {
			$nc_more_posts_by_author = $nc_author_url;
			return "<a href='$nc_author_url'>" . $nc_this_is_the_author_name . "</a>";
		} else {
			return $nc_this_is_the_author_name;
		}
	}
}
if(!function_exists('nc_generate_post_summary')){
	function nc_generate_post_summary() {
		$id = get_the_ID();
		$postLink = get_permalink();
		$postTitle = get_the_title();
		$getMorePostsByAuthor = nc_generate_more_posts_by_author_link();
		$postTime = get_the_time( get_option( 'date_format' ) );
		$postTitleAndMeta = <<<EOT
			<h2><a href="$postLink" rel="bookmark">$postTitle</a></h2>
			<div class="excerpt_meta">
				<span class="meta-prep meta-prep-author">By </span>
				<span class="author vcard">$getMorePostsByAuthor</span>
				<span class="meta-sep"> | </span>
				<span class="meta-prep meta-prep-entry-date">Posted on </span>
				<span class="entry-date"><abbr class="published">$postTime</abbr></span>
			</div>
EOT;
		$postExcerpt = apply_filters('the_excerpt', get_the_excerpt());
		$postExcerpt .= shareThisWrapper();
		if ( has_post_thumbnail() ) {
			$thumbnail = get_the_post_thumbnail($id, 'postThumbMult', array('class' => 'postThumbMult'));
			$postExcerptWrapper = <<<EOT
			<div class="post_entry_mult_left">
				$thumbnail
			</div>
			<div class="post_entry_mult_right">
				$postTitleAndMeta
				$postExcerpt
			</div>
EOT;
		} else {
			$postExcerptWrapper = <<<EOT
			$postTitleAndMeta
			$postExcerpt
EOT;
		}
		$preppedExcerpt = <<<EOT
		<div class="post_entry_mult">
			$postExcerptWrapper
		</div><!-- post-entry -->
EOT;
		echo $preppedExcerpt;
	}
}

if(!function_exists('nc_author_rel')){
	function nc_author_rel() {
		global $nc_enable_rel_author_url, $nc_author_url;
		if(isset($nc_enable_rel_author_url)) { ?>
			<link rel="author" href="<?php echo $nc_author_url; ?>"/>
		<?php
		}
	}
}
add_action('wp_head', 'nc_author_rel');

remove_action('wp_head', 'wp_generator');



if(!function_exists('map_shortcode')){
	function map_shortcode($atts) {
		extract( shortcode_atts( array(
			'latitude' => 0,
			'longitude' => 0,
			'zoom' => 14,
			'image' => get_stylesheet_directory_uri() . "/img/map-marker.png"
		), $atts ) );
		global $google_map_count;
		if($google_map_count == null) {
			$google_map_count = 1;
			$fetchGoogleMapScript = "<script src='https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false'></script>";
		} else {
			$google_map_count++;
			$fetchGoogleMapScript = "";
		}
		$id = "map" . $google_map_count;
		$map_to_display = <<<EOT
		<div id="$id" class="google-map"></div>
		$fetchGoogleMapScript
		<script type="text/javascript">
			function initializeMap{$google_map_count}() {
				var mapOptions = {
					zoom: $zoom,
					center: new google.maps.LatLng($latitude, $longitude),
					mapTypeControl: false
				}
				var map = new google.maps.Map(document.getElementById("$id"), mapOptions);
				var myLatLng = new google.maps.LatLng($latitude, $longitude);
				var mapMarker = new google.maps.Marker({
					position: myLatLng,
					map: map,
					icon: "$image"
				});
			}
			google.maps.event.addDomListener(window, 'load', initializeMap{$google_map_count});
		</script>
EOT;
		return $map_to_display;
	}
}
add_shortcode('map', 'map_shortcode');

/* Exclude iPad from wp_is_mobile() */
if(!function_exists('dsk_wp_is_mobile')) {
	function dsk_wp_is_mobile() {
		static $is_mobile;

		if ( isset($is_mobile) )
			return $is_mobile;

		if ( empty($_SERVER['HTTP_USER_AGENT']) ) {
			$is_mobile = false;
		} elseif (
			strpos($_SERVER['HTTP_USER_AGENT'], 'Android') !== false
			|| strpos($_SERVER['HTTP_USER_AGENT'], 'Silk/') !== false
			|| strpos($_SERVER['HTTP_USER_AGENT'], 'Kindle') !== false
			|| strpos($_SERVER['HTTP_USER_AGENT'], 'BlackBerry') !== false
			|| strpos($_SERVER['HTTP_USER_AGENT'], 'Opera Mini') !== false ) {
				$is_mobile = true;
		} elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'Mobile') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'iPad') == false) {
				$is_mobile = true;
		} elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'iPad') !== false) {
			$is_mobile = false;
		} else {
			$is_mobile = false;
		}
		return $is_mobile;
	}
}
if(!function_exists('add_opengraph_support')) {
	function add_opengraph_support() {
		global $post;
		$seo_title = get_post_meta( $post->ID, '_title', true );
		$siteName = get_bloginfo( 'name' );
		if( $seo_title == '' ) {$title = $siteName;}
		else {$title = $seo_title;}
	 ?>
	<meta property="og:title" content="<?php echo $title; ?>"/>
	<?php
	$postInHead = get_post();
	$social_media_description = $postInHead->post_content;
	$social_media_description = strip_tags(substr($social_media_description,0,240));
	$social_media_description = str_replace('\n', ' ', $social_media_description);
	$lastSpacePos = strripos($social_media_description, " ");
	$social_media_description = substr($social_media_description, 0, $lastSpacePos) . "...";
	?>
	<meta property="og:description" content="<?php echo $social_media_description; ?>" />
	<meta property="og:url" content="<?php the_permalink(); ?>"/>
	<?php $social_media_image = wp_get_attachment_image_src(get_post_thumbnail_id( get_the_ID() ), 'postThumbSingle'); ?>
	<?php if ( $social_media_image && ( is_page() || is_single() ) ) : ?>
		<meta property="og:image" content="<?php echo $social_media_image[0]; ?>" />
	<?php else : ?>
		<meta property="og:image" content="<?php echo get_stylesheet_directory_uri(); ?>/img/sm-profile/firm-logo.png" />
	<?php endif; ?>
	<meta property="og:type" content="<?php if(is_single() || is_page()) echo 'article'; else echo 'website'; ?>" />
	<meta property="og:site_name" content="<?php bloginfo('name'); ?>" />
<?php
	}
}
add_action('wp_head', 'add_opengraph_support');


if(!function_exists('web_crumbs')) {
	function web_crumbs($id = "crumbs", $delimiter = ">", $home = "Home", $before = '<span class="current">', $after = '</span>') {

		if ( !is_home() && !is_front_page() && is_page()) {

			echo "<div id='{$id}'>";

			global $post;
			$homeLink = get_bloginfo('url');
			echo "<a class='breadcrumb_home' href='{$homeLink}'>{$home}</a> {$delimiter} ";

			if ( is_page() && !$post->post_parent ) {
				echo $before . get_the_title() . $after;
			} elseif ( is_page() && $post->post_parent ) {

				$parent_id  = $post->post_parent;
				$breadcrumbs = array();
				while ($parent_id) {
					$page = get_page($parent_id);
					$breadcrumbs[] = '<a href="' . get_permalink($page->ID) . '">' . get_the_title($page->ID) . '</a>';
					$parent_id  = $page->post_parent;

				}

				$breadcrumbs = array_reverse($breadcrumbs);
				foreach ($breadcrumbs as $crumb) echo $crumb . ' ' . $delimiter . ' ';
				echo $before . get_the_title() . $after;

			}
			echo '</div>';
		}
	}
}//web_crumbs ends



?>